Blame SOURCES/cryptsetup-2.3.4-fix-crypto-backend-to-properly-handle-ECB-mode.patch

644931
From f3906957675e466bbe7fa97a725f56c7c494d4a5 Mon Sep 17 00:00:00 2001
644931
From: Milan Broz <gmazyland@gmail.com>
644931
Date: Tue, 21 Jul 2020 14:14:54 +0200
644931
Subject: [PATCH] Fix crypto backend to properly handle ECB mode.
644931
644931
Despite it should be never used, it should still work :)
644931
644931
Bug introduced in version 2.3.2.
644931
---
644931
 lib/crypto_backend/crypto_storage.c | 2 +-
644931
 tests/compat-test2                  | 9 +++++++++
644931
 2 files changed, 10 insertions(+), 1 deletion(-)
644931
644931
diff --git a/lib/crypto_backend/crypto_storage.c b/lib/crypto_backend/crypto_storage.c
644931
index 8b6c19c..92dbae7 100644
644931
--- a/lib/crypto_backend/crypto_storage.c
644931
+++ b/lib/crypto_backend/crypto_storage.c
644931
@@ -64,7 +64,7 @@ static int crypt_sector_iv_init(struct crypt_sector_iv *ctx,
644931
 	memset(ctx, 0, sizeof(*ctx));
644931
 
644931
 	ctx->iv_size = crypt_cipher_ivsize(cipher_name, mode_name);
644931
-	if (ctx->iv_size < 8)
644931
+	if (ctx->iv_size < 0 || (strcmp(mode_name, "ecb") && ctx->iv_size < 8))
644931
 		return -ENOENT;
644931
 
644931
 	if (!strcmp(cipher_name, "cipher_null") ||
644931
diff --git a/tests/compat-test2 b/tests/compat-test2
644931
index 0fad999..c3852cd 100755
644931
--- a/tests/compat-test2
644931
+++ b/tests/compat-test2
644931
@@ -1023,5 +1023,14 @@ echo $PWD3 | $CRYPTSETUP luksConvertKey --key-slot 22 $LOOPDEV --keyslot-cipher
644931
 [ "$($CRYPTSETUP luksDump $IMG | grep -A8 -m1 "22: luks2" | grep "Cipher:"    | sed -e 's/[[:space:]]\+Cipher:\ \+//g')" = $KEYSLOT_CIPHER ] || fail
644931
 [ "$($CRYPTSETUP luksDump $IMG | grep -A8 -m1 "22: luks2" | grep "Cipher key:"| sed -e 's/[[:space:]]\+Cipher\ key:\ \+//g')" = "128 bits" ] || fail
644931
 
644931
+prepare "[42] Some encryption compatibility mode tests" wipe
644931
+CIPHERS="aes-ecb aes-cbc-null aes-cbc-plain64 aes-cbc-essiv:sha256 aes-xts-plain64"
644931
+key_size=256
644931
+for cipher in $CIPHERS ; do
644931
+	echo -n "[$cipher/$key_size]"
644931
+	$CRYPTSETUP -q luksFormat --type luks2 $LOOPDEV $KEY1 $FAST_PBKDF_OPT --cipher $cipher --key-size $key_size || fail
644931
+done
644931
+echo
644931
+
644931
 remove_mapping
644931
 exit 0
644931
-- 
644931
1.8.3.1
644931